<?

class GUIVFrameObject extends GUIObject {

var $d_rightHtml;
var $d_useVFrames;
var $d_updateInterval;
var $d_updateURL;
var $d_isUTF8 = false;
var $d_containsNonUTF8 = false;
var $d_contentType = 'text/html';
var $d_history;

function GUIVFrameObject($type) {
parent::GUIObject($type);
$this->d_useVFrames = false;
$this->d_rightHtml = "";
$this->d_updateInterval = -1;
$this->setUTF8(true);
$this->d_history = new GUIHistory($type);
}

function addColumnHtml($html) {
$this->d_rightHtml .= $html;
}

function setContentType( $header ) {
$this->d_contentType = $header;
}

function getContentType( ) {
if ($this->d_contentType) 
{
return $this->d_contentType;
} else
{
return false;
}

}

function enableVFrames($enable = true) {
$this->d_useVFrames = $enable;
}

function setUpdateInterval( $seconds )
{
$this->d_updateInterval = $seconds;
}

function getUpdateInterval()
{
return $this->d_updateInterval;
}

function getHeader()
{
if ( $this->isPlain() ) return;
global $HTML_HEAD, $STAG, $DO;
if ( $this->d_updateInterval >  0 )
{
$HTML_HEAD .= "\n <meta http-equiv=\"refresh\" content=\"".
$this->d_updateInterval."; URL=";
if ( $this->d_updateURL )
$HTML_HEAD .= $this->d_updateURL;
else
$HTML_HEAD .= "$STAG&do=$DO";
$HTML_HEAD .= "\">\n";
}
return parent::getHeader();
}

function getHTML() {
if ( $this->isPlain() ) return;
$html = parent::getHTML();
if ($this->d_useVFrames) $html .= "<table border=0 cellspacing=0 cellpadding=0><tr valign=top align=left><td>";
return $html;
}

function getFooter() {
if ( $this->isPlain() ) return;
if ($this->d_useVFrames) {
if ($this->d_rightHtml) {
$html .= "</td><td>&nbsp;&nbsp;</td><td>".$this->d_rightHtml;
}
$html .= "</td></tr></table>";
}
$html .= parent::getFooter();
return $html;
}


//                                                               
 
function setUTF8( $isUTF8 = true )
{
$this->d_isUTF8 = $isUTF8;
}

function setContainsNonUTF8( $contains = true )
{
$this->d_containsNonUTF8 = $contains;
}

function isUTF8()
{
global $FEATURE;
if ( !$FEATURE["UTF8"] ) return false;
return $this->d_isUTF8;
}

function containsNonUTF8()
{
return $this->d_containsNonUTF8;
}

function flagAsUTF8( $content )
{
global $FEATURE;
if ( !$FEATURE["UTF8"] ) return $content;
return "||UTF8||".GUIVFrameObject::stripUTF8Flag( $content )."||-UTF8||";
}

function stripUTF8Flag( $text )
{
$text = str_replace("||UTF8||", "", $text);
$text = str_replace("||-UTF8||", "", $text);
return $text;
}

function encodeFlaggedUTF8Recursive( $content, $startPos=0, $depth=0 )
{
$ret = "";
$utf8Prefix = "||UTF8||";
$utf8Postfix = "||-UTF8||";
$prefixLen = strlen( $utf8Prefix );
$postfixLen = strlen( $utf8Postfix );
$endPos = true;
$pos = strpos( $content, $utf8Prefix, $startPos );
while( $pos !== false || $endPos !== false )
{
$endPos = strpos( $content, $utf8Postfix, $startPos );
if ( $endPos === false )
{
$text = substr( $content, $startPos );
if ( $depth == 0 ) $text = utf8_encode($text);
$ret .= $text;
}
else if ( $endPos < $pos || $pos === false )
{
$ret .= substr( $content, $startPos, $endPos-($startPos) );
return array( "text"=>$ret, "nextpos"=>$pos, "endpos"=>$endPos+$postfixLen );
}
else
{
$text = substr( $content, $startPos, $pos-$startPos );
if ( $depth == 0 ) $text = utf8_encode($text);
$ret .= $text;
$res = GUIVFrameObject::encodeFlaggedUTF8Recursive($content, $pos+$prefixLen, $depth+1);	
$ret .= $res["text"];
$startPos = $res["endpos"];
if ( $startPos !== false )
$pos = strpos( $content, $utf8Prefix, $startPos );
else
$pos = false;
}

} //      
 return array( "text"=>$ret, "pos"=>$pos, "endpos"=>($endPos!==false)?($endPos+$postfixLen):false );
}

function encodeFlaggedUTF8( $content )
{
$ret = GUIVFrameObject::encodeFlaggedUTF8Recursive($content);
return $ret["text"];
}


function sendHttpHeaders() 
{
global $FEATURE;
if ( $FEATURE["UTF8"] && $this->isUTF8() )
http_header($this->getContentType(), "UTF-8");
else
http_header();
}

function prepareOutput( $buffer ) 
{
//               
 global $FEATURE;
if ( $this->isUTF8()  && $this->containsNonUTF8() )
return GUIVFrameObject::encodeFlaggedUTF8($buffer);
else
return $buffer;
}

/**
  *                                         
  **/
function clearHistory() 
{
$this->d_history->clear();
}

/**
  *                                                               
  *                                                                                                       
  *                                                                                                                          
  *                                               
  **/
function enterHistory($vars = array(), $keepFuture = 2) 
{
global $guiframe_histpos;

$entry = $this->d_history->createEntry($vars);;

$curr = $this->d_history->getCurrentEntry();

//                                                          
 
if ( !$this->d_history->isSameEntry($curr, $entry) ) {

$this->d_history->addEntry($entry, !$keepFuture || !(isset($guiframe_histpos) && $keepFuture == 2) );

}

}

function historyBack($defaultDo = false, $defaultVars = array()) 
{
global $GUIFRAME_HISTORY, $REDO, $DO;

$curr = $this->d_history->getCurrentEntry();
if ( $this->d_history->isCurrentEntry($curr) ) {
$last = $this->d_history->getEntry(-1, true);
} else {
$last = $this->d_history->getEntry(0, true);
}

if ( !$last ) {
if ( $defaultDo ) {
$REDO = $defaultDo;
foreach ($defaultVars as $name=>$val) {
global $$name;
$$name = $val;
}
}
return false;
} else {
$REDO = $last["do"];
foreach ($last["vars"] as $name=>$val) {
global $$name;
$$name = $val;
}
}

return true;
}

function getHistoryLink($pos = -1) 
{
global $GUIFRAME_HISTORY, $STAG;

//                                             
 $curr = $this->d_history->getCurrentEntry();
if ( !$this->d_history->isCurrentEntry($curr) && $pos < 0 ) {
$pos++;
}
$entry = $this->d_history->getEntry($pos);
if ( !$entry ) {
return "";
}

$link = "$STAG&do=".$entry["do"]."&guiframe_histpos=";

return $link;

}

function historyHasPrev()
{
return $this->d_history->hasPrev();
}

function historyHasNext() 
{
return $this->d_history->hasNext();
}

}

class GUIMainObject extends GUIVFrameObject {


function GUIMainObject() {
parent::GUIVFrameObject("main");
}

function redirectToLastMain()
{
global $REDO, $LAST_MAIN_DO, $DO;
if ( isset( $LAST_MAIN_DO ) )
{
if ( $LAST_MAIN_DO != $DO )
{
$REDO = $LAST_MAIN_DO;
return true;
}
}
return FALSE;
}


function getHTML()
{
global $LAST_MAIN_DO, $DO;
mysession_var_reg( "LAST_MAIN_DO" );
$LAST_MAIN_DO = $DO;
return parent::getHTML();
}


}

class GUIDialogObject extends GUIVFrameObject {

function GUIDialogObject() {
parent::GUIVFrameObject("dialog");
}

}

class GUIPopupDialogObject extends GUIVFrameObject {

function GUIPopupDialogObject() {
parent::GUIVFrameObject("popup");
}

function getHeader() {
global $JS, $JS_ONLOAD, $HTML_NODE_BODY_END, $FEATURE;

//                                                /                                                 /    

if($FEATURE['autoresize_popups']) {
$JS .= '

function height() {
  if (document.body.scrollHeight != undefined) {
    return document.body.scrollHeight + 5;
  }
  if (typeof document.height != "undefined") {
    return document.height;
  }
  if (document.compatMode && document.compatMode != "BackCompat") {
    return document.documentElement.scrollHeight;
  }
  if (document.body && typeof document.body.scrollHeight != "undefined") {
    return document.body.scrollHeight;
  }
}
function width() {
  //alert("document.body.scrollWidth: " + document.body.scrollWidth + " / document.width: " + document.width + " / document.documentElement.scrollWidth: " + document.documentElement.scrollWidth + " / document.body.scrollWidth: " +  document.body.scrollWidth);
  if (document.body && typeof document.body.scrollWidth != "undefined") {
    // FF3, IE7, IE6 ... great.. we do not actually need the rest..
    return document.body.scrollWidth;
  }
  /*
  if (typeof document.width != "undefined") {
    return document.width;
  }
  if (document.compatMode && document.compatMode != "BackCompat") {
    return document.documentElement.scrollWidth;
  }
  if (document.body.scrollWidth != undefined) {
    return document.body.scrollWidth;
  }
  */
}

function getInnerHeight() {
  if(window.innerHeight != undefined) {
    return window.innerHeight;
  }
  if(document.documentElement && document.documentElement.clientHeight) {
    return document.documentElement.clientHeight;
  }
  return document.body.clientHeight;
}
function getInnerWidth() {
  //if(window.innerWidth != undefined) {
  //  return window.innerWidth;
  //}
  if (document.documentElement != undefined && document.documentElement.clientWidth != undefined && document.documentElement.clientWidth > 0) {
    return document.documentElement.clientWidth;
  }
  return document.body.clientWidth;
}
function getScreenWidth() {
  return screen.availWidth;
}
function getScreenHeight() {
  return screen.availHeight;
}
function getMarginWidth() {
  if(window.outerWidth == undefined) return 30;
  return window.outerWidth - getInnerWidth();
}
function getMarginHeight() {
  if(window.outerHeight == undefined) return 50;
  return window.outerHeight - getInnerHeight();
}
function getWindowX() {
  if(window.screenX == undefined) return window.screenLeft;
  return window.screenX;
}
function getWindowY() {
  if(window.screenY == undefined) return window.screenTop;
  return window.screenY;
}

function adjustWindowSize() {
  var resX = width() - getInnerWidth();
  var resY = height() - getInnerHeight();

  if(resX < 0) resX = 0;
  if(resY < 0) resY = 0;

  if (getInnerWidth() + resX > screen.availWidth) {
     resX = screen.availWidth - getInnerWidth() - 100;
  }
  if (getInnerHeight() + resY > screen.availHeight) {
     resY = screen.availHeight - getInnerHeight() - 100;
  }

  // we do not care about 20 pixel scroll bars... (i guess)
  if (resX >= 20 || resY >= 20) {
    top.window.resizeBy(resX, resY);
  }

}

';
$JS_ONLOAD = '
//window.innerHeight = screen.availHeight;
adjustWindowSize();
';
}

return parent::getHeader();
}

}

class GUIShellObject extends GUIObject {

function GUIShellObject() {
parent::GUIObject("shell");
}

function getHeader(){
//                         
 }
function getFooter() {
//                         
 }

function getHTML(){
//                   
 }

function printHaltPage($halt_id, $detail) {
echo "\nError [$halt_id]: $detail\n\n";
}

}

define( "IMG_TYPE_PNG", "png" );
define( "IMG_TYPE_JPEG", "jpeg" );
define( "IMG_TYPE_GIF", "gif" );

class GUIImageObject extends GUIObject {

var $d_type = "";
var $d_contentType = "";
var $d_filename = "";
var $d_noCache = false;

function GUIImageObject()
{
parent::GUIObject( "image" );
}

function setContentType( $header ) {
$this->d_contentType = $header;
}

function getContentType( ) {
if ($this->d_contentType) 
{
return $this->d_contentType;
} else
{
return false;
}

}

function setImageType( $type )
{
$this->d_type = $type;
}

function setFilename( $filename ) {
$this->d_filename = $filename;
}

function sendHttpHeaders() 
{
if ( !$this->d_noCache ) {
$exp_gmt = gmdate("D, d M Y H:i:s", time() + 5184000) . " GMT";
$mod_gmt = gmdate("D, d M Y H:i:s", getlastmod()) . " GMT";
header("Expires: " . $exp_gmt);
header("Last-Modified: " . $mod_gmt);
header("Cache-Control: public");
header("Cache-Control: max-age=5184000");
}
if ( $this->d_type )
header( "Content-Type: image/".$this->d_type );
else if ($this->d_contentType)
header( "Content-Type: ".$this->d_contentType );

if ($this->d_filename) {
header( "Content-Disposition: filename=".$this->d_filename );
}

}

function getHeader() {	
//                        
 }

function getHTML() {}

function getFooter() {}
}

class GUIHistory {

var $guiName;

function GUIHistory($name) {
$this->guiName = $name;
}

function clear() {
global $GUIFRAME_HISTORY;
$GUIFRAME_HISTORY[$this->guiName] = array();	
}

function &getHistory() {
global $GUIFRAME_HISTORY;
if ( !isset($GUIFRAME_HISTORY[$this->guiName] ) ) {
$GUIFRAME_HISTORY[$guiName] = array("curr"=>-1, "hist"=>array());
}
return $GUIFRAME_HISTORY[$this->guiName];
}

function getCurrentEntry()
{	
$hist =& $this->getHistory();
return $hist["curr"] == -1 ? array() : $hist["hist"][$hist["curr"]];
}

function addEntry($entry, $clearFuture) {

$hist =& $this->getHistory();

//                                      
 
$hist["curr"]++;
$hist["hist"][$hist["curr"]] = $entry;

if ( $clearFuture ) {
$count = count($hist["hist"]);
for ($i = $count - 1; $i > $curr; $i--) {
unset($hist["hist"][$i]);
}
}
}

function getEntry($offset, $makeActive) {

$hist =& $this->getHistory();

$curr = $hist["curr"] + $offset;
if ( !isset($hist["hist"][$curr]) ) {
return false;
}
if ( $makeActive ) {
$hist["curr"] = $curr;
}
return $hist["hist"][$curr];
}

function isSameEntry($entry1, $entry2) {
if ( $entry1["do"] != $entry2["do"] ) {
return false;
}
if ( count($entry1["vars"]) != count($entry2["vars"]) ) {
return false;
}
foreach ($entry1["vars"] as $key=>$val) {
if ( $entry2["vars"][$key] != $val ) {
return false;
}
}
return true;
}

function isCurrentEntry($entry) {

$curr = $this->createEntry(array_keys($entry["vars"]));

return $this->isSameEntry($entry, $curr);
}

function createEntry($_varNames_) {
global $DO;

$_vars_ = array();
foreach ($_varNames_ as $_name_) {
global $$_name_;
$_vars_[$_name_] = $$_name_;
}

return array("do"=>$DO, "vars"=>$_vars_);
}

function hasPrev() {
global $GUIFRAME_HISTORY;
$hist = $GUIFRAME_HISTORY[$this->guiName];
return isset($hist) && $hist["curr"] > 0;
}

function hasNext() {
global $GUIFRAME_HISTORY;
$hist = $GUIFRAME_HISTORY[$this->guiName];
return isset($hist) && $hist["curr"] < count($hist["hist"]) - 1;
}
}

//                                                                    #     
//                  
$EXEC_FUNC[] = "initGuiFrame";

function initGuiFrame() {
mysession_var_reg("GUIFRAME_HISTORY", true);
}

?>
