<?

//                             
global $NODE_CONSISTENCY_OBJECTS;
$NODE_CONSISTENCY_OBJECTS = array();

class ConsistencyObject extends BaseObject {

var $m_keyname;

function ConsistencyObject($keyname) {
$this->m_keyname = $keyname;
}

function getKeyname() {
return $this->m_keyname;
}

function getName() {}

function getInfo() {}

function getDescription() { return "&nbsp;"; }

function check() { return true; }

function getCheckResult() {}

function canCleanup() { return false; }

function cleanup() {}

function getCommands() {
return NULL;
}

function execute($command) {
}
}

class SQLConsistencyObject extends ConsistencyObject {

var $m_sql;
var $m_desc;
var $m_delTable;
var $m_delId;
var $m_delId2;
var $m_count;

function SQLConsistencyObject($keyname, $sql, $desc = "", $delTable = "", $delId = "id", $delId2 = "") {
parent::ConsistencyObject($keyname);
$this->m_sql = $sql;
$this->m_delTable = $delTable;
$this->m_delId = $delId;
$this->m_delId2 = $delId2;
$this->m_desc = $desc;
}

function getSQL() {
return $this->m_sql;
}

function getName() {
return $this->getKeyname();
}

function getInfo() {
return $this->getSQL();
}

function getDescription() {
return ($this->m_desc)?$this->m_desc:"&nbsp;";
}

function check() {
$rs = query($this->getSQL());//            
 $this->m_count = $rs["num"];
return $rs["num"];
}

function getCheckResult() {
return $this->m_count;
}

function canCleanup() {
return ($this->m_delTable != "");
}

function cleanup() {
$rs = query($this->getSQL());//            
 while (list($key, $val) = each($rs["arr"])) {
$sql = "DELETE FROM ".sqlf_table($this->m_delTable)." WHERE ".sqlf_field($this->m_delId)." = ".sqlf_value($val[$this->m_delId]);
if ($this->m_delId2) $sql .= " AND ".sqlf_field($this->m_delId2)." = ".sqlf_value($val[$this->m_delId2]);
query($sql);//            
 }
}
}

class DependencyConsistencyObject extends ConsistencyObject {

var $m_ttype;
var $m_desc;
var $m_idCol;
var $m_table;
var $m_count;
var $m_ids;

function DependencyConsistencyObject($keyname, $ttype, $table, $idCol = "id", $desc="" )  {
parent::ConsistencyObject($keyname);
$this->m_ttype = $ttype;
$this->m_idCol = $idCol;
$this->m_table = $table;
$this->m_desc = $desc;
}

function getSQL( $modOrDep ) {
$sql = "SELECT map.id, map.mod_type, map.mod_id, map.dep_type, map.dep_id FROM dependencymap map ".
"LEFT JOIN ".sqlf_table($this->m_table)." t1 ON (map.".sqlf_field("${modOrDep}")."_id = t1.".sqlf_field($this->m_idCol)." ) ".
"WHERE (t1.".sqlf_field($this->m_idCol)." IS NULL ) ".
"AND map.".sqlf_field("${modOrDep}")."_type = ".sqlf_tl_num($this->m_ttype);
return $sql;
}

function getName() {
return $this->getKeyname();
}

function getInfo() {
return $this->getSQL("mod")."<br>\n".$this->getSQL("dep");
}

function getDescription() {
return ($this->m_desc)?$this->m_desc:"&nbsp;";
}

function check() {
$rs = query($this->getSQL("mod"));//            
 $this->m_count = $rs["num"];
$this->m_ids["mod"] = $rs["arr"];
$rs = query($this->getSQL("dep"));//            
 $this->m_count += $rs["num"];
$this->m_ids["dep"] = $rs["arr"];
return $this->m_count;
}

function getCheckResult() {
return $this->m_count;
}

function canCleanup() {
return true;
}

function cleanup() {
$this->check();
$ids = array();
foreach ( $this->m_ids["mod"] as $row )
$ids[] = $row["id"];
foreach ( $this->m_ids["dep"] as $row )
$ids[] = $row["id"];

$sql = "DELETE FROM dependencymap WHERE id IN (".implode(",", sqlf_tl_num_array($ids)).")";
query( $sql );//            
 }
}

class ConsistencyFactory extends BaseObject {

function loadObjects() {
//                                                                  
 node_include("CONSISTENCY");
}

function register(&$cobject) {
global $NODE_CONSISTENCY_OBJECTS;
if (!is_a($cobject, "consistencyobject")) return false;
$NODE_CONSISTENCY_OBJECTS[$cobject->getKeyname()] =& $cobject;
}

function &getObjects() {
global $NODE_CONSISTENCY_OBJECTS;
return $NODE_CONSISTENCY_OBJECTS;
}

function &getObject($key) {
global $NODE_CONSISTENCY_OBJECTS;
return $NODE_CONSISTENCY_OBJECTS[$key];
}

}

///                                         
class Consistency extends BaseObject {

var $m_prefix = "";
var $m_text = "";
var $m_objects = array();

var $m_checks = 0;
var $m_checkErrors = 0;
var $m_checkErrorCount = 0;

function Consistency($prefix = "sys") {
parent::BaseObject();
$this->m_prefix = $prefix;
$this->m_objects =& ConsistencyFactory::getObjects();
$this->initFromSubmit();
}

function initFromSubmit() {
$delName = $this->m_prefix."del";
global $$delName;
if ($$delName) {
$obj =& ConsistencyFactory::getObject($$delName);
$obj->cleanup();
$this->m_text .= "deleted ".$$delName."!<br>";
}

$objkeyName = $this->m_prefix."objkey";
$cmdName = $this->m_prefix."cmd";
global $$objkeyName, $$cmdName;
if ($$objkeyName) {
$obj =& ConsistencyFactory::getObject($$objkeyName);
$r = $obj->execute( $$cmdName );
$this->m_text .= $r ? $r : "Executed ".$$cmdName." on ".$$delName."!<br>";
}
}

//                                                                            
 function checkObjects($flushInfo = false) {
$this->m_checks = 0;
$this->m_checkErrors = 0;
$this->m_checkErrorCount = 0;
foreach ($this->m_objects as $key=>$obj) {
if ($flushInfo) echo "<!-- checking $key -->\n";
$rs = $this->m_objects[$key]->check();
$this->m_checks++;
if ($rs) {
$this->m_checkErrors++;
$this->m_checkErrorCount += $rs;
}
}
}

function getCheckCount() {
return $this->m_checks;
}

function getErrors() {
return $this->m_checkErrors;
}

function getErrorCount() {
return $this->m_checkErrorCount;
}

function storeResult() {
$err = $this->getErrors();
$errc = $this->getErrorCount();

$sql = "SELECT name FROM nodesetup WHERE name = 'estat'";
$rs = query($sql);//            
 if ($rs["num"] == 0) $sql = "INSERT INTO nodesetup (name,intvalue) VALUES ('estat',$err)";
else $sql = "UPDATE nodesetup SET intvalue = ".sqlf_tl_num($err)." WHERE name = 'estat'";
query($sql);//            
 
$sql = "SELECT name FROM nodesetup WHERE name = 'estatc'";
$rs = query($sql);//            
 if ($rs["num"] == 0) $sql = "INSERT INTO nodesetup (name,intvalue) VALUES ('estatc',".sqlf_tl_num($errc).")";
else $sql = "UPDATE nodesetup SET intvalue = ".sqlf_tl_num($errc)." WHERE name = 'estatc'";
query($sql);//            
 }

function getHtmlOutput() {
global $JS, $DIC, $STAG, $DO;

$JS .= "
function askdel(obj,url) {
	check = confirm(\"Delete \"+obj+\"?\");
	if (check == true) location.href=url;
}
		";

$out = "<p>".$this->m_text."</p>\n";

$out .= "<table border=1 cellspacing=0>
		<tr><td><b>".$DIC[1466]."</b></td><td><b>".$DIC[867]."</b></td><td><b>".$DIC[3]."</b></td><td>".$DIC[1677]."</td></tr>
		";

foreach ($this->m_objects as $key=>$obj) {
$key = $this->m_objects[$key]->getKeyname();
$name = $this->m_objects[$key]->getName();
$info = $this->m_objects[$key]->getInfo();
$desc = $this->m_objects[$key]->getDescription();
$result = $this->m_objects[$key]->getCheckResult();

$out .= "<tr valign=top>\n";
if ($this->m_objects[$key]->canCleanup()) {
$out .= "<td>$key <a href=\"javascript:askdel('$name ($key)','$STAG&do=$DO&".$this->m_prefix."del=$key');\">x</a>";
$cmds = $this->m_objects[$key]->getCommands();
if($cmds !== NULL) {
foreach( $cmds as $cmd ) {
$out .= " <a href=\"javascript:askdel('$name ($key)','$STAG&do=$DO&".$this->m_prefix."objkey=$key&".$this->m_prefix."cmd=".$cmd['cmd']."');\" title=\"".$cmd['title']."\">".$cmd['label']."</a>";
}
}
$out .= "</td>\n";
}
else $out .= "<td>$key</td>\n";

$out .= "<td>$result</td><td>$info</td><td>$desc</td></tr>\n";
}

$out .= "</table>";

return $out;
}

function getStatsOutput() {
global $DIC;

$err = $this->getErrors();
$errc = $this->getErrorCount();

$out = $DIC[1681]." ".$this->getCheckCount()." ".$DIC[1682].".<br><br>";

if (!$err) $out .= "<b>".$DIC[1678]."</b>";
else {
$out .= "<font color=red><b>".$DIC[1679].": $err ";
if ($err == 1) $out .= $DIC[1519]; else $out .= $DIC[1680];
$out .= "</b></font>";
}

if ($count = $this->getCheckCount()) $percent = 100 - round(($err/$count) * 100);

$out .= " (";
if ($percent == 100)   $out .= $DIC[1689];
elseif ($percent > 80) $out .= $DIC[1683];
elseif ($percent > 50) $out .= $DIC[1684];
elseif ($percent > 30) $out .= $DIC[1685];
elseif ($percent > 0)  $out .= $DIC[1686];
else $out .= $DIC[1687];
$out .= ", ".$percent."% ".$DIC[1688]."!)";

return $out;
}

}

?>
